/*
 *  MCMemoryStats.h
 *  MemoryCell
 *
 *  Created by Quentin Carnicelli on Thu Jun 10 2004.
 *  Copyright (c) 2004 Rogue Amoeba Software, LLC. All rights reserved.
 *
 */

#include <unistd.h>
#include <mach/mach_types.h>

typedef enum
{
	 kProcessInvalidMemorySize = 0
	,kProcessPrivateMemorySize
	,kProcessRealMemorySize
	,kProcessSharedMemorySize
	,kProcessVirtualPrivateMemorySize
	,kProcessVirtualMemorySize
}process_memory_stat_unit; //These are serialzied so don't fiddle

typedef enum
{
	kProcessMemoryStatsOK,
	kProcessMemoryStatsNoData,
	kProcessMemoryStatsError,
}process_memory_stats_status;

typedef struct
{
	pid_t		fPid;
	process_memory_stats_status	fStatus;
	long		fTimestamp;
	vm_size_t	fRsize;
	long		fRsizeChange;
	vm_size_t	fVsize;
	long		fVsizeChange;
	vm_size_t	fRprvt;
	long		fRprvtChange;
	vm_size_t	fVprvt;
	long		fVprvtChange;
	vm_size_t	fRshrd;
	long		fRshrdChange;
}process_memory_stats;

kern_return_t process_get_mem_stats( pid_t pid, const process_memory_stats* lastStats, process_memory_stats* outStats );

vm_size_t	process_mem_stats_get_value( const process_memory_stats* inStats, process_memory_stat_unit inType );
vm_size_t process_mem_stats_get_value_change( const process_memory_stats* inStats, process_memory_stat_unit inType );

kern_return_t process_mem_stats_as_data( const process_memory_stats* inStats, CFDataRef* outData );
kern_return_t process_mem_stats_from_data( CFDataRef inData, process_memory_stats* outStats );

