//
//  MCProcessMonitor.h
//  MemoryCell
//
//  Created by Quentin Carnicelli on 9/10/06.
//  Copyright 2006 Rogue Amoeba Software, LLC. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "MCMemoryStats.h"

@class MCHelperToolClient;

@interface MCProcessMonitor : NSObject
{
	NSTimer*				mNonretainedTimer;
	MCHelperToolClient*		mHelperTool;
	NSMutableDictionary*	mProcesses;
}

- (id)init;

- (pid_t)foregroundProcess;
- (const process_memory_stats*)statsForProcess: (pid_t)pid;

@end

__private_extern__ NSString* MCProcessMonitorChangeNotification;
